module GROESTL_TOP(
   clk, rst_n,
   init, load, fetch,
   idata, odata,
   ack, EOM
);

//{{{ input & output
input clk;
input rst_n;
input EOM;

input init;
input load;
input fetch;

output ack;

input [15:0] idata;
output [15:0] odata;
//}}}

//{{{ wire
wire [255:0] hash;

wire Ld_msg;
wire busy;
wire start;
//}}}

GROESTL_INTERFACE groestl_interface(
   .clk(clk), .rst_n(rst_n),
   .load(load), .fetch(fetch),
   .odata(odata),
   .busy(busy), .start(start), .ack(ack), .Ld_msg(Ld_msg),
   .hash(hash)
);

GROESTL_CORE groestl_core(
   .clk(clk), .rst_n(rst_n),
   .init(init), .busy(busy), .Ld_msg(Ld_msg), .idata(idata), 
   .hash(hash), .EOM(EOM),
   .start(start)
);

endmodule

// vim:fdm=marker
